#!/usr/bin/python
#   coding: utf-8

from pad.logger import Logger
logger = Logger()

def null( el, style, props ):
  return ''

class Content:
  def __init__(self):
    self.content = ''
    self.styles = {}
    self.scripts = {}

  def __add__(self, other):
    if isinstance( other, unicode ):
      self.content += other
    elif isinstance( other, str ):
      self.content += other.decode('utf-8')
    elif isinstance( other, Content ):
      self.content += other.content
      for key in other.styles.keys():
        self.updateStyle( other.styles[key], key)
      self.scripts.update( other.scripts )
    else:
      raise ValueError("cannot add incompatible types")
    return self

  def updateStyle(self, *args):
    for i in range(0,len(args),2):
      if self.styles.has_key( args[i+1] ):
        if isinstance( args[i], dict):
          self.styles[ args[i+1] ].update( args[i] )
        else:
          self.styles[ args[i+1] ][ args[i] ] = None
      else:
        if isinstance( args[i], dict):
          self.styles[ args[i+1] ] = args[i]
        else:
          self.styles[ args[i+1] ] = { args[i]: None }

  def updateScript(self, text):
    if isinstance( text, list ):
      for item in text:
        self.scripts[item]=None
    else:
      self.scripts[text]=None

  def getContent(self):
    return self.content

  def getStyles(self):
    s = ''
    for key in self.styles:
      if key.strip():
        selector = ',\n'.join( self.styles[key].keys() )
        s += selector + ' {' + key + '}\n'
    return s

  def getScripts(self):
    return '\n\n'.join(self.scripts.keys())
