#!/usr/bin/python
#   coding: utf-8

import re
import datetime
import sys
import codecs

def getUnicode(aargh):
  if isinstance(aargh,unicode):
    return aargh
  try:
    return aargh.decode('utf-8')
  except:
    try:
      aaargh = repr(aargh)
    except:
      return u"<Object with broken repr()>"
    aaaargh = re.sub('[^ -~]','.',aaargh)
    return aaaargh.decode('ascii')

class Logger:
  levelNames = [' ERROR ','warning','message',' debug ','verbose']

  def __init__(self, level=3):
    self.level=level
    self.output = codecs.getwriter('utf-8')(sys.stderr)

  def log(self, level, *args):
    if isinstance( level, int ):
      exception = None
    elif issubclass( level, Exception ):
      exception = level
      level = 0

    comment = u''.join( [getUnicode(arg) for arg in args] )

    if level<=self.level:
      self.output.write(u''.join([unicode(datetime.datetime.now().isoformat()),
		' [',Logger.levelNames[level],'] '])+comment+'\n')

    if exception: raise exception( comment )


if __name__=='__main__':
  logger = Logger()
  logger.log(1, "Page '", u'\u0413\u041b\u0410\u0412\u041d\u0410\u042f', "': latest version ", '20080405142209377002', ', submission parent ', '20080405133306290103')
