#!/usr/bin/python
#   coding: utf-8

from pad.logger import Logger
logger = Logger()

def latest( storage, ns, path, *args ):

  n = int( args[-1] )
  searchPath = '/'.join( args[:-1])+'/9'

  logger.log(3, 'Getting ',n,' latest pages in path ',searchPath)

  content = '''<!DOCTYPE page SYSTEM "http://www.colourcountry.net/xmlns/page" ><page>
      <title>Index</title>
      <shortdesc />
      <body>
'''

  for sibling in storage.listPrecedingSiblings( ns, searchPath, n )[1:]:
    siblingTree = storage.get( ns, sibling )

    title = siblingTree.getPath('title')
    logger.log(3,'Found title ',title)
    if title is not None:
      title = title.text
    else:
      title = 'Untitled'

    content += '<link href="'+str(sibling)+'">'+title+'</link>'

  content += '''
      </body>
</page>
'''

  return content

