#!/usr/bin/python
#   coding: utf-8

import pad.helper
from pad.logger import Logger
logger = Logger()

class Setter:
  def __init__(self, setterDef):
    self.setterDef = setterDef

  def getProperties(self, el, props):
    if self.setterDef.has_key(el.tag):
      props = self.setterDef[el.tag].apply(el, props)
    for child in el:
      self.getProperties( child, props )


class Attribute:
  def __init__(self, property, attributeName):
    self.property = property
    self.attributeName = attributeName

  def apply(self, el, props, default=None):
    value = el.get( self.attributeName, default )
    logger.log(3,self,' ',el.tag,': ',self.property,'=',value)
    props[self.property] = value

  def __repr__(self):
    return '(Set '+self.property+' to value of @'+self.attributeName+')'
