#!/usr/bin/python
#   coding: utf-8

import pad.types
from pad.content import Content
from pad.logger import Logger
logger = Logger()

def null( el, style, props ):
  return ''

class Style:
  def getEditor( self, tag, props ):
    def getEditorFromTagDef( tagDef, props ):
      logger.log(4, 'Getting editor',tagDef)
      for i in range((len(tagDef)-1)/2*2,-2,-2):
        conditions = tagDef[i]
        logger.log(4, 'Conditions for ',tagDef[i+1],': ',tagDef[i])
        if not conditions:
          logger.log(4, 'No conditions to satisfy')
          return tagDef[i+1]
        else:
          satisfied = True
          for j in range(0,len(conditions),2):
            propvalue = props.get(conditions[j], None)
            logger.log(4, 'Checking condition ',conditions[j],'=',conditions[j+1],' vs ',propvalue)
            if propvalue is None or propvalue != conditions[j+1]:
              satisfied = False
              break
          if satisfied:
            logger.log(4, 'All satisfied')
            return tagDef[i+1]
        logger.log(4, 'Not satisfied, trying next')
      logger.log(4, 'No conditions satisfied')
      return None

    thetype = None
    if self.types.has_key(tag):
      thetype = getEditorFromTagDef( self.types[tag], props )

    if thetype is None:
      thetype = getEditorFromTagDef( self.types[None], props )

    return thetype

  def apply( self, el, props, content=None ):
    logger.log(3,'Styling ',el)
    logger.log(4,'with properties ',props)

    if content is None:
      content = Content()

    newprops = props.copy()

    if props.has_key('location'):
      selected = props['location'][0].split(',')
      logger.log(3, '--', selected)
      if len(selected)==1:
        del(newprops['location'])
        selected = int(selected[0])
      else:
        newprops['location']=[','.join(selected[1:])]
        selected = None
    else:
      selected = None

    if not props.has_key('action'):
      newprops['action'] = 'edit'

    for index,item in enumerate(el):
      thetype = None
      tag = None

      if index==selected:
        newprops['focus'] = 'yes'
      else:
        newprops['focus'] = 'no'

      thetype = self.getEditor( item.tag, newprops )

      if thetype is None: thetype = pad.types.structure.Flag()
        
      logger.log(3,item.tag+"["+str(index)+"]: using ",thetype)

      if el.tag.startswith("{http://www.colourcountry.net/xmlns/pad}"):
        # tags in the above namespace are markers for conflicts and the like
        newprops['_this'] = props.get('_this','')
      else:
        if props.has_key('_this'):
          newprops['_this']=props['_this']+','+str(index)
        else:
          newprops['_this']=str(index)

      thetype.apply( item, self, newprops, content )

    return content

  def __init__(self, elems):
    if isinstance( elems, dict ):
      self.types = elems
    elif elems=="read":
      self.types = { None: 	( None,		types.structure.Block() ) }
    #elif elems=="edit":
    #  self.types =
    #'p':		( None,		types.text.Block(),
    #			('action', 'edit', 'focus', 'yes'),
    #					types.text.BlockSplit(),
    #			),
