#!/usr/bin/python
#   coding: utf-8

import urllib
import random
import pad.helper

class Type:
  @classmethod
  def _getQuery( self, props ):
    href = u'location='+pad.helper.makeattr(props['_this'])
    if props.has_key('path'):
      href += u'&path='+pad.helper.makeattr(props['path'])
    return href

  @classmethod
  def getHref( self, props ):
    return u'?'+self._getQuery( props )+'#f'

  @classmethod
  def getActiveHref( self, props ):
    return u'#'+self._getQuery( props )

  @classmethod
  def getColour( self, text ):
    if text == 'body':
      return '#00aa00'
    elif text == 'title':
      return '#ee4400'
    elif text == 'shortdesc':
      return '#eebb00'
    else:
      x = random.Random(text)
      c = [ hex(x.randrange(128)+256+128)[-2:], hex(x.randrange(128)+256+64)[-2:], hex(x.randrange(128)+256)[-2:] ]
      x.shuffle(c)
      return '#'+''.join(c)

  @classmethod
  def getLocation( self, props, attribute=None ):
    if attribute:
      return pad.helper.makeattr( props['_this']+',@'+attribute )
    else:
      return pad.helper.makeattr( props['_this'] )


  editInit = '''init = function() {
  if ( window.scrollY < window.scrollMaxY ) {
    window.scrollBy( 0, -window.innerHeight/3 );
  }
  thefocus = document.getElementById('focus');
  thefocus.focus();
  thefocus.selectionStart = 0;
}'''

  typeName = 'type'

  def __init__( self, **aargs ):
    self.options = aargs

  def apply( self, el, style, props, content ):
    content += '\n<!-- '+self.__class__.typeName+' '+el.tag+' -->\n'
    self.getContent( el, style, props, content )
    content.updateStyle( *self.getStyle( el, props ) )
    content.updateScript( self.getScript( el, props ) )

  def getSelector( self, el, props ):
    parentName = props.get( 'parent', None )
    if parentName is None:
      return u' .'+pad.helper.makecssname( el.tag )
    else:
      return u' .'+pad.helper.makecssname( parentName )+u' .'+pad.helper.makecssname( el.tag )

  def getStyle( self, el, props ):
    selector = self.getSelector( el, props )
    return selector, self.options.get( 'style', '' )

  def getScript( self, el, props ):
    return u''

  def getText( self, el ):
    return el.text

  def __repr__( self ):
    return self.__class__.__name__+u' '+str(self.options)
