#!/usr/bin/python
#   coding: utf-8

from pad.type import Type
from pad.helper import *
from pad.logger import Logger
logger = Logger()

class BlockButtons(Type):
  typeName = 'pad.types.active.choice.BlockButtons'

  def getText( self, el ):
    if self.options.has_key('attribute'):
      thetext = el.get( self.options['attribute'] )
    else:
      thetext = el.text
    return thetext

  def getContent( self, el, style, props, content):
    href = Type.getActiveHref( props )
    location = Type.getLocation( props, self.options.get('attribute', None) )
    thetext = self.getText( el )
    theTag = makeattr(el.tag)

    if self.options.has_key('choices'):
      thechoices = '<div class="_edit" style="display:none" >'+thetext+' &#x2192; '
      for choice in self.options['choices']:
        if choice!=thetext:
          thechoices += '<input class="_button" type="button" name="choice" value="'+makeattr(choice)+'" />'
      thechoices += '</div>'

    theStyle = self.options.get( 'style', '' )

    content += u'''
<div class="'''+theTag+u'''"><div class="_">
  <form name="form_'''+location+u'''">
    <a class="_button" style="'''+theStyle+'''" onclick="choice_blockbuttons_activate(this)">'''+thetext+'''</a>
    <input type="hidden" name="location" value="'''+location+'''" />
    <input type="hidden" name="action" value="replace" />
    <input type="hidden" name="a" value="'''+thetext+'''" />
'''+thechoices+'''
    <input type="hidden" name="b" value="'''+thetext+'''" />
  </form>
</div>
'''

    content += style.apply( el, props )
    content += u'\n</div><!-- end '+el.tag+u' -->\n'

  def getScript( self, el, props ):
    return [
'''
choice_blockbuttons_deactivate = function( p ) {
  return function() {
    var node = p.parentNode;
    var newValue = node.elements['b'].value;
    p.firstChild.nodeValue = newValue;

    theButtons = node.elements['choice'];
    if (!theButtons.length) {
      theButtons.parentNode.style.display="none";
    } else {
      theButtons[0].parentNode.style.display="none";
    }

    p.style.display="inline";
    window.pad_activeNode = null;
    window.pad_forceDecision = null;
  }
}
''','''
choice_blockbuttons_warn = function() {
  var node = window.pad_activeNode;
}
''','''
choice_blockbuttons_activate = function( p ) {

  if (window.pad_forceDecision != null) {
    window.pad_forceDecision();
    return false;
  }

  var node = p.parentNode;
  window.pad_activeNode = node;

  var theText = "";
  if (p.getAttribute("class") != "_editlink") {
    theText = p.firstChild.nodeValue;
  }

  window.pad_touch( node );

  window.pad_deactivate();
  window.pad_deactivate = choice_blockbuttons_deactivate( p );

  if (node.elements['a'].value == '') {
    node.elements['a'].value = theText;
  }

    theButtons = node.elements['choice'];
    if (!theButtons.length) {
      theButtons = [theButtons];
    }

    for (var i=0, b; b=theButtons[i++];) {
      b.onclick = function( button ) {
        return function( e ) {
          node.elements['b'].value = button.value;
          window.pad_submit( button );
        }
      }(b);
      b.parentNode.style.display="block";
    }
  
  p.style.display = "none";

}
''']


