#!/usr/bin/python
#   coding: utf-8

from pad.type import Type
from pad.helper import *

class Block(Type):
  typeName = 'pad.types.choice.Block'

  def getText( self, el ):
    if self.options.has_key('attribute'):
      thetext = el.get( self.options['attribute'] )
    else:
      thetext = el.text
    return thetext


  def getContent( self, el, style, props, content ):
    href = Type.getHref( props )

    if self.options.has_key('attribute'):
      thetext = el.get( self.options['attribute'] )
    else:
      thetext = el.text

    content += u'<div class="'+makeattr(el.tag)+u'"><div class="_">'
    if thetext and thetext.strip():
      content += u'<a href="'+href+'" class="_text">'+maketext(thetext)+u'</a></div>'
    else:
      content += u'<a href="'+href+'" class="_editlink">&#x270e;</a></div>'
    content += style.apply( el, props )
    content += u'</div>\n'



class BlockDropdown(Type):
  typeName = 'pad.types.choice.BlockDropdown'

  def getText( self, el ):
    if self.options.has_key('attribute'):
      thetext = el.get( self.options['attribute'] )
    else:
      thetext = el.text
    return thetext


  def getContent( self, el, style, props, content):
    thetext = self.getText( el )

    if self.options.has_key('choices'):
      thechoices = ''
      for choice in self.options['choices']:
        thechoices += '<option value="'+makeattr(choice)+'" '
        if choice == thetext: thechoices += 'selected="selected" '
        thechoices += '>'+maketext(choice)+'</option>'
    else:
      thechoices = '<option value="None">No choices</option>'

    content += u'<a name="f"></a>'
    content += u'<div class="'+makeattr(el.tag)+u'''"><div class="_edit">
<input type="hidden" name="location" value="'''+Type.getLocation( props, self.options.get('attribute',None) )+'''" />
<input type="hidden" name="action" value="replace" />
<input type="hidden" name="a" value="'''+makeattr(thetext)+'''" />
<select id="focus" name="b">'''+thechoices+'''</select>
<button type="submit">Save</button></div></div>\n'''

  def getScript( self, el, props ):
    return Type.editInit;



class BlockButtons(Type):
  typeName = 'pad.types.choice.BlockButtons'

  def getText( self, el ):
    if self.options.has_key('attribute'):
      thetext = el.get( self.options['attribute'] )
    else:
      thetext = el.text
    return thetext


  def getContent( self, el, style, props, content):
    thetext = self.getText( el )

    if self.options.has_key('choices'):
      thechoices = ''
      for choice in self.options['choices']:
        if choice!=thetext:
          thechoices += '<input class="_button" type="submit" name="b" value="'+makeattr(choice)+'" />'
    thechoices = thetext + ' &#x2192; ' + thechoices
    content += u'<a name="f"></a>'
    content += u'<div class="'+makeattr(el.tag)+u'''"><div class="_edit">
<input type="hidden" name="location" value="'''+Type.getLocation( props, self.options.get('attribute',None) )+'''" />
<input type="hidden" name="action" value="replace" />
<input type="hidden" name="a" value="'''+makeattr(thetext)+'''" />
<div id="focus"> '''+thechoices+'''</div></div>\n'''

  def getScript( self, el, props ):
    return Type.editInit;
