#!/usr/bin/python
#   coding: utf-8

from pad.type import Type
from pad.helper import *
from pad.logger import Logger
logger = Logger()

class Editor(Type):
  def getContent( self, el, style, props, content ):

    content += u'<a name="f"></a>'
    content += u'<div class="'+makeattr(el.tag)+u'''"><div class="_edit">
<input type="hidden" name="location" value="'''+Type.getLocation( props )+'''" />
<input type="hidden" name="action" value="replace" />
<textarea class="_full" id="b" name="b" dojoType="dijit.Editor">'''
    content += formatChildren( el )
    content += u'</textarea><input type="hidden" name="a" value="'
    content += makeattr( formatChildren( el ) )
    content += u'" /><button type="submit" onclick="submitForm(\'form\')">Save</button></div></div>\n'



  def getScript( self, el, props ):
    # FF2/3 do not submit form contents.
    # Most of this script is a workaround function for this bug.
    # See http://dojotoolkit.org/book/dojo-book-0-9/part-2-dijit/advanced-editing-and-display/editor-rich-text
    return '''dojo.require("dijit.Editor");
dojo.addOnLoad(function(){
    console.log("onLoad fires after require() is done"); 
});

function submitForm(dijitForm) {
    if ( dojo.isString(dijitForm) ) dijitForm = dijit.byId(dijitForm);
    if ( dijitForm.validate() ) {
        if ( dojo.isFF ) {
            var aDijits = dijitForm.getDescendants();
            var dijitChild, sName, sValue, eTextarea;
            for ( var i=0, max=aDijits.length; i<max; i++ ) {
                dijitChild = aDijits[i];
                if ( dijitChild.domNode.className.indexOf('RichTextEditable')!=-1) {
                    sName = dijitChild.domNode.getAttribute('widgetid');
                    sValue = dijitChild.getValue();
                    eTextarea = document.createElement('textarea');
                    dijitForm.domNode.appendChild(eTextarea);
                    eTextarea.name = sName;
                    eTextarea.value = sValue;
                    eTextarea.style.display = 'none';
                }
            }
        }
        dijitForm.submit();
    }
    return false;
}'''

