#!/usr/bin/python
#   coding: utf-8

import random

from pad.type import Type
from pad.helper import *

class Block(Type):
  typeName = 'pad.types.structure.Block'

  def getContent( self, el, style, attrs, content ):
    theStyle = self.options.get( 'style', '' )
    content += u'<div class="'+makeattr(el.tag)+u'" style="'+theStyle+'">'
    if el.text and el.text.strip():
      content += u'<div class="_">'+maketext(el.text)+u'</div>'
    content += style.apply( el, attrs )
    content += u'</div>\n'



class Flag(Type):
  typeName = 'pad.types.structure.Flag'

  def getContent( self, el, style, attrs, content ):
    content += u'<div class="'+makeattr(el.tag)+u'">'
    content += u'<h4>'+makeNameAndAttrs(el)+u'</h4>'
    if el.text and el.text.strip():
      content += u'<div class="_">'+maketext(el.text)+u'</div>'
    content += style.apply( el, attrs )
    content += u'</div>\n'

  def getStyle( self, el, props ):
    selector = self.getSelector( el, props )
    colour = self.options.get( 'flagColour', Type.getColour( el.tag ) )

    sideStyle = 'border-left: 5px solid '+colour+'; border-bottom: 5px solid transparent; margin-left: 5px;'
    sideStyle += self.options.get( 'style', '' )
    flagStyle = 'color: '+colour+'; font-size: 10px; padding: 0 0 0.5em 0.5em; '
    flagStyle += self.options.get( 'flagStyle', '' )
    return selector, sideStyle, selector+'>h4', flagStyle

  def getScript( self, el, props ):
    return ''

