#!/usr/bin/python
#   coding: utf-8

import re
import pad.model
import pad.validator
import pad.setter

from pad.logger import Logger
logger = Logger()


class Page(pad.model.Model):
  def getValidator( self ):
    validDef = {
	None:		( None,		pad.validator.Allow(),
			('lock', 'locked'),
					pad.validator.Deny(),
			),
	'lock':		( None,		pad.validator.Allow(),
			),
	}

    return { 'edit': pad.validator.ByTag ( validDef ) }

  def getSetter( self ):
    setterDef = {
	'lock':		pad.setter.Attribute('lock','value')
	}

    return pad.setter.Setter ( setterDef )

  def getStyles( self ):
    editDef = { 
	None:		( None,		pad.types.structure.Flag(),
			),
	'lock':		(
			('action', 'edit', 'focus', 'yes', 'lock', 'locked'),
					pad.types.choice.BlockButtons(
						attribute='value',
						choices=('unlocked',),
					),
			('action', 'edit', 'focus', 'yes', 'lock', 'unlocked'),
					pad.types.choice.BlockButtons(
						attribute='value',
						choices=('blocked',),
					),
			('action', 'edit', 'focus', 'yes', 'lock', 'blocked'),
					pad.types.choice.BlockButtons(
						attribute='value',
						choices=('locked', 'blocked', 'unlocked'),
					),
			None,		pad.types.choice.Block(
						attribute='value',
						style='color: #0000ff;',
					),
			),
	'p':		( 
			('lock', 'locked'),
					pad.types.structure.Block(
						style='padding-bottom: 0.5em; background-color: #cccccc;'
					),
			('action', 'edit', 'focus', 'yes'),
					pad.types.text.BlockSplit(
						style='padding-bottom: 0.5em;'
					),
			None,		pad.types.text.Block(
						style='padding-bottom: 0.5em;'
					),
			),

	'link':		(
			('action', 'edit', 'focus', 'yes'),
					pad.types.link.BlockEdit(),
			None,		pad.types.link.Block(),
			),

	'page':		( None,		pad.types.structure.Flag( flagColour='black' ),
			),

	'title':	(
			('action', 'edit', 'focus', 'yes'),
					pad.types.text.FlagEdit(
						style='font-weight:bold;font-size:24pt;'
					),
			None,		pad.types.text.Flag(
						style='font-weight:bold;font-size:24pt;'
					),
			),

	'shortdesc':	(
			('action', 'edit', 'focus', 'yes'),
					pad.types.text.FlagEdit(),
			None,		pad.types.text.Flag(),
			),
	}

    return { 'edit': pad.style.Style( editDef ) }

  def getTemplate( self, ns, path, title=None ):
    if title is None:
      title = re.sub('[^/]*/','',path)

    return '''<!DOCTYPE page SYSTEM "http://wherever.org.uk/" >
<page>
  <title>'''+title+'''</title>
  <shortdesc>This page has not yet been saved.</shortdesc><body>
  <lock value="unlocked" />
  <p />
  </body>
</page>
'''

