#!/usr/bin/python
#   coding: utf-8

from pad.logger import Logger
logger = Logger()

def null( el, style, props ):
  return ''

class Content:
  def __init__(self):
    self.content = { None: [] }

  def addToKey(self, key, other):
    if isinstance( other, unicode ):
      self.content[None].append( other )
    elif isinstance( other, str ):
      self.content[None].append( other.decode('utf-8') )
    elif isinstance( other, list ):
      self.content[None].extend( other )
    else:
      raise ValueError("cannot add incompatible types")

  def __add__(self, other):
    if isinstance( other, dict ):
      self._embiggen( other )
    elif isinstance( other, Content ):
      self._embiggen( other.content )
    else:
      self.addToKey( None, other )
    return self

  def _embiggen(self, other):
    for key in other:
      if self.content.has_key(key):
        self.addToKey( key, other[key] )
      elif isinstance( other[key], list ):
        self.content[key] = other[key]
      else:
        self.content[key] = [ other[key] ]

  def __setitem__(self, key, value):
    self.content[key] = [value]

  def __getitem__(self, key):
    return self.content[key]

  def get(self, key=None):
    return self.content.get( key, [] )

  def concat(self, key=None):
    return ''.join( self.get( key ) )

  def __repr__(self):
    return repr(self.content)
