#!/usr/bin/python
#   coding: utf-8

from pad.type import Type, JSType
from pad.helper import *
from pad.logger import Logger
logger = Logger()

class Block(JSType):
  typeName = 'pad.types.js.text.Block'

  emptyContent = unichr(0x270e)+" click to add text"

  def getContent( self, el, style, props, content ):
    href = Type.getActiveHref( props )
    location = Type.getLocation( props )

    if el.text and el.text.strip():
      theText = maketext( el.text )
      theClass = "_text"
    else:
      theText = Block.emptyContent;
      theClass = "_editlink"
 
    theTag = makeattr(el.tag)

    theStyle = self.options.get( 'style', '' )

    # &#x238c; is the real undo symbol

    content += u'''
<div class="'''+theTag+u'''"><div class="_">
  <form name="form_'''+location+u'''">
    <a style="display: block; '''+theStyle+'" class="'+theClass+'" onclick="'+self.getOnClick()+'">'+theText+'''</a>
    <input type="hidden" name="location" value="'''+location+'''" />
    <input type="hidden" name="action" value="replace" />
    <input type="hidden" name="a" value="" />
    <input type="hidden" name="b" value="" class="_full" style="'''+theStyle+'''"/>
    <button type="button" style="display:none" name="submit">&#x2714;</button>
    <button type="button" style="display:none" name="cancel">&#x21b6;</button>
  </form>
</div>
'''
    content += style.apply( el, props )
    content += u'\n</div><!-- end '+el.tag+u' -->\n'

    content += { 'requires': '"'+self.typeName+'"' }
