#!/usr/bin/python
#   coding: utf-8

# Import Psyco if available
try:
  import psyco
  psyco.full()
except ImportError:
  pass

import web
import os, re, sys, time, urllib
import page
import pad
from socket import gethostname

logger = pad.logger.Logger()

localNS = gethostname()
baseDir = 'content'
modelNS = 'malachi.colourcountry.net/models/html'
#modelNS = localNS + '/models/html'

firstModel = 'page'
firstPage = 'index'

href = 'http://localhost:8080/pad'
storage = pad.storage.DeltaStorage( 'content' )

storage.addMagic( 'magic/latest/', pad.magic.latest )

models = pad.model.ModelRegister( storage, modelNS )

htmlView = pad.views.Ajax	(storage=storage,
#htmlView = pad.views.Blog(	storage=storage,
				href=href,
				styleName='edit',
				ns=localNS,
				models=models
	 )



urls = (	'/pad/(.*)', 	'PageHandler',
		'/([^/]+)', 	'DefaultRedirect',
		'/', 		'IndexRedirect',
	)

class DefaultRedirect:
  def GET(self, name):
    if name in ['favicon.ico','robots.txt','.htaccess']:
      web.notfound()
    else:
      web.seeother( '/pad/'+name )

class IndexRedirect:
  def GET(self):
    web.seeother( '/static/app.html' )
    #web.seeother( '/pad/'+localNS.replace('/','+')+'/'+firstModel+'/'+firstPage )

class PageHandler:
  def handleResponse( self, result, arg ):
    if result=='seeother':
      logger.log(3, 'Result: redirect to ',arg )
      web.seeother( arg )
    elif result=='html' or not result:
      logger.log(3, 'Result: HTML content type' )
      web.header('Content-Type','text/html; charset=utf-8')
      print arg
    else:
      logger.log(3, 'Result: explicit content type ',result )
      web.header('Content-Type',result)
      print arg

  def GET(self, page):
    self.handleResponse( *htmlView.serve( page.decode('utf-8'), web.ctx.query.decode('utf-8') ) )

  def POST(self, page):
    self.handleResponse( *htmlView.submit( page.decode('utf-8'), web.input() ) )

web.webapi.internalerror = web.debugerror

if __name__=="__main__": web.run(urls, globals(), web.reloader)
if __name__=="__msain__":  print htmlView.serve(localNS+'/index', '')
