(function() {

  var Editor = function( clicked, props ) {
    var self = this;
    self.input = clicked;
    self.form = clicked.parentNode;
    self.props = props;
    clicked.onclick = function() { self.activate( self ) };
  };

  Editor.prototype.deactivate = function( self ) {
    var newValue = self.form.elements['b'].value;
    if (newValue == "") {
      self.input.firstChild.nodeValue = "'''+Block.emptyContent+'''";
      self.input.setAttribute("class","_editlink");
    } else {
      self.input.firstChild.nodeValue = newValue;
      self.input.setAttribute("class","_text");
    }
    self.form.elements['b'].type="hidden";
    self.form.elements['submit'].style.display="none";
    self.form.elements['cancel'].style.display="none";
    self.input.style.display="block";
    PAD.state.activeNode = null;
    PAD.state.forceDecision = null;
  };

  Editor.prototype.warn = function() {
    var node = PAD.state.activeNode;
  };

  Editor.prototype.activate = function( self ) {

    if (PAD.state.forceDecision != null) {
      PAD.state.forceDecision();
      return false;
    }

    PAD.state.activeNode = self.form;

    var theText = "";
    if (self.input.getAttribute("class") != "_editlink") {
      theText = self.input.firstChild.nodeValue;
    }

    //PAD.state.touch( self.form );

    PAD.state.deactivate();
    PAD.state.deactivate = function() { self.deactivate(self) };

    PAD.state.submit = function() {
      PAD.utils.dumpObject(self.props);
      PAD.utils.dumpObject(PAD.utils.findProps(self.form));
      PAD.actions.submit( self.form, self.props );
    }

    if (self.form.elements['a'].value == '') {
      self.form.elements['a'].value = theText;
    }

    self.form.elements['b'].value = theText;
    self.form.elements['b'].type = "text";
    self.form.elements['b'].focus();
    self.form.elements['b'].setSelectionRange( theText.length, theText.length );

    self.input.style.display = "none";

    self.form.elements['b'].onkeydown = function( e ) {
      self.form.elements['submit'].style.display = "inline";
      self.form.elements['cancel'].style.display = "inline";
      if ( e.keyCode == 13 ) {
        PAD.state.submit( e.target, self.props );
        return false;
      }
      PAD.state.forceDecision = self.warn;
    };

    self.form.elements['cancel'].onclick = function( e ) {
      self.form.elements['b'].value = self.form.elements['a'].value;
      self.deactivate(self);
      PAD.state.deactivate = PAD.utils.doNothing;
    };

    self.form.elements['submit'].onclick = function( e ) {
      PAD.state.submit();
    };
  };



  var module = {};

  module.activate = function( element, props ) {
    editor = new Editor( element, props );
    editor.activate( editor );
  };

  return module;

}())
