#!/usr/bin/env python2.3

from sqlobject import *

from datetime import datetime

now=datetime.now()

sqlhub.processConnection = connectionForURI('mysql://colourcountry:fr0st1es@localhost/colourcountry')

class ccPage(SQLObject):
  mediaURI = StringCol()
  mediaThumbnailURI = StringCol()
  mediaTeaserURI = StringCol()
  mediaType = StringCol()
  mediaThumbnailType = StringCol()
  mediaTeaserType = StringCol()
  mediaSize = IntCol()
  tags = RelatedJoin('ccTag')
  dateCreated = DateTimeCol()
  dateEntered = DateTimeCol()
  dateUpdated = DateTimeCol()
  name = StringCol()
  description = StringCol()
  timesViewed = IntCol()

class ccTag(SQLObject):
  name  = StringCol()
  pages = RelatedJoin('ccPage')
  comments = StringCol()
  description = StringCol()
  type = StringCol()
  isImportant = BoolCol()
  logoURI = StringCol()

if __name__=="__main__":
  for page in ccPage.select():
    print page

if __name__=='NEVER DO THIS':
  ccPage.dropTable(cascade=True)
  ccPage.createTable()
  ccTag.dropTable(cascade=True)
  ccTag.createTable()

  design = ccTag( name='design', type='activity', comments='Design and graphics', isImportant = True, logoURI='cc4.png' )
  photos = ccTag( name='photography', type='activity', comments='Photography', isImportant = True, logoURI='cc2.png' )
  audio  = ccTag( name='audio', type='activity', comments='Audio and music', isImportant = False, logoURI = 'cc3.png' )
  online = ccTag( name='online', type='activity', comments='Web applications', isImportant = True, logoURI = 'cc5.png' )
  meta   = ccTag( name='meta', type='activity', comments='About the site and myself', isImportant = True, logoURI='cc6.png' )

  places = ccTag( name='places', type='subject', comments='Travel and places', isImportant = False, logoURI='' )
  tube = ccTag( name='tube', type='subject', comments='London Underground', isImportant = False, logoURI='' )
  london = ccTag( name='london', type='subject', comments='London', isImportant = False, logoURI='' )
  
  silly = ccTag( name='silly', type='mood', comments='Silly or frivolous', isImportant = False, logoURI='' )

  z = ccPage(   mediaURI='275-Places/media.pdf',
		mediaType='application/pdf',
		mediaSize=25559,
		mediaThumbnailURI='275-Places/thumb.png',
		mediaThumbnailType='image/png',
		dateCreated=datetime(2005,2,8,13,0,0),
		dateEntered=now,
		dateUpdated=now,
		timesViewed=0,
		name=u'275 Places',
		description=u'''<p>This grid of dots is topologically equivalent to the London Underground map.</p>
	
<blockquote>"It occurred to me that it might be possible to tidy up the map by straightening the lines, evening out the distance between stations. The more I thought about it, the more I thought it was worth trying." &ndash; Harry Beck</blockquote>

<p>A drawing for those of us who think Mr. Beck just didn't go far enough.
Every station is exactly 1 unit away from four other stations. By necessity,
these aren't often the stations which are actually connected to it, but I have
tried to make all the interconnections as short as possible. Naturally, no
interconnection passes through a false grid point on the way.</p>''')
  z.addCcTag(design)
  z.addCcTag(tube)

  z = ccPage(   mediaURI='Posting-Animals/media.pdf',
		mediaType='application/pdf',
		mediaSize=236045,
		mediaThumbnailURI='Posting-Animals/thumb.png',
		mediaThumbnailType='image/png',
		dateCreated=datetime(2006,1,18,13,0,0),
		dateEntered=now,
		dateUpdated=now,
		timesViewed=0,
		name=u'Posting Animals?',
		description='''<p>Inspired by <a href="http://news.bbc.co.uk/1/hi/magazine/4623754.stm">this sick hamster prank</a>,
a public information poster for you to print out and stick by the outgoing
mail tray in your office.</p>'''
		)
  z.addCcTag(design)
  z.addCcTag(silly)


  z = ccPage(   mediaURI='The-Palm-House/media.jpg',
		mediaType='image/jpeg',
		mediaSize=763479,
		mediaThumbnailURI='The-Palm-House/thumb.jpg',
		mediaThumbnailType='image/png',
		dateCreated=datetime(2006,1,3,13,0,0),
		dateEntered=now,
		dateUpdated=now,
		timesViewed=0,
		name=u'The Palm House',
		description=''
		)
  z.addCcTag(photos)


